diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/examples/wifi-bianchi.cc ns-3.44/src/wifi/examples/wifi-bianchi.cc
--- ns-3.43/src/wifi/examples/wifi-bianchi.cc	2024-10-09 16:41:10.112656800 -0700
+++ ns-3.44/src/wifi/examples/wifi-bianchi.cc	2025-03-09 16:55:49.775372500 -0700
@@ -39,9 +39,12 @@
 #include "ns3/wifi-mac-header.h"
 #include "ns3/wifi-mac.h"
 #include "ns3/wifi-net-device.h"
+#include "ns3/wifi-phy-rx-trace-helper.h"
+#include "ns3/wifi-tx-stats-helper.h"
 #include "ns3/yans-wifi-helper.h"
 
 #include <fstream>
+#include <iomanip>
 #include <vector>
 
 /// Avoid std::numbers::pi because it's C++20
@@ -104,6 +107,8 @@
 bool tracing = false;    ///< Flag to enable/disable generation of tracing files
 uint32_t pktSize = 1500; ///< packet size used for the simulation (in bytes)
 uint8_t maxMpdus = 0;    ///< The maximum number of MPDUs in A-MPDUs (0 to disable MPDU aggregation)
+bool useTxHelper = false; ///< Flag to get MPDU statistics with WifiTxStatsHelper
+bool useRxHelper = false; ///< Flag to get PPDU statistics with WifiPhyRxTraceHelper
 
 /// Table of the expected values for EIFS
 std::map<std::string /* mode */,
@@ -1896,8 +1901,8 @@
 /**
  * Parse context strings of the form "/NodeList/x/DeviceList/x/..." to extract the NodeId integer
  *
- * \param context The context to parse.
- * \return the NodeId
+ * @param context The context to parse.
+ * @return the NodeId
  */
 uint32_t
 ContextToNodeId(std::string context)
@@ -1910,8 +1915,8 @@
 /**
  * Parse context strings of the form "/NodeList/x/DeviceList/x/..." and fetch the Mac address
  *
- * \param context The context to parse.
- * \return the device MAC address
+ * @param context The context to parse.
+ * @return the device MAC address
  */
 Mac48Address
 ContextToMac(std::string context)
@@ -1935,11 +1940,11 @@
 // Functions for tracing.
 
 /**
- * Incremement the counter for a given address.
+ * Increment the counter for a given address.
  *
- * \param [out] counter The counter to increment.
- * \param addr The address to incremement the counter for.
- * \param increment The incremement (1 if omitted).
+ * @param [out] counter The counter to increment.
+ * @param addr The address to increment the counter for.
+ * @param increment The increment (1 if omitted).
  */
 void
 IncrementCounter(std::map<Mac48Address, uint64_t>& counter,
@@ -1960,13 +1965,13 @@
 /**
  * Trace a packet reception.
  *
- * \param context The context.
- * \param p The packet.
- * \param channelFreqMhz The channel frequqncy.
- * \param txVector The TX vector.
- * \param aMpdu The AMPDU.
- * \param signalNoise The signal and noise dBm.
- * \param staId The STA ID.
+ * @param context The context.
+ * @param p The packet.
+ * @param channelFreqMhz The channel frequqncy.
+ * @param txVector The TX vector.
+ * @param aMpdu The AMPDU.
+ * @param signalNoise The signal and noise dBm.
+ * @param staId The STA ID.
  */
 void
 TracePacketReception(std::string context,
@@ -2018,8 +2023,8 @@
 /**
  * Contention window trace.
  *
- * \param context The context.
- * \param cw The contention window.
+ * @param context The context.
+ * @param cw The contention window.
  */
 void
 CwTrace(std::string context, uint32_t cw, uint8_t /* linkId */)
@@ -2036,8 +2041,8 @@
 /**
  * Backoff trace.
  *
- * \param context The context.
- * \param newVal The backoff value.
+ * @param context The context.
+ * @param newVal The backoff value.
  */
 void
 BackoffTrace(std::string context, uint32_t newVal, uint8_t /* linkId */)
@@ -2054,9 +2059,9 @@
 /**
  * PHY Rx trace.
  *
- * \param context The context.
- * \param p The packet.
- * \param power The Rx power.
+ * @param context The context.
+ * @param p The packet.
+ * @param power The Rx power.
  */
 void
 PhyRxTrace(std::string context, Ptr<const Packet> p, RxPowerWattPerChannelBand power)
@@ -2068,9 +2073,9 @@
 /**
  * PHY Rx trace.
  *
- * \param context The context.
- * \param txVector The TX vector.
- * \param psduDuration The PDSU diration.
+ * @param context The context.
+ * @param txVector The TX vector.
+ * @param psduDuration The PDSU diration.
  */
 void
 PhyRxPayloadTrace(std::string context, WifiTxVector txVector, Time psduDuration)
@@ -2083,9 +2088,9 @@
 /**
  * PHY Drop trace.
  *
- * \param context The context.
- * \param p The packet.
- * \param reason The drop reason.
+ * @param context The context.
+ * @param p The packet.
+ * @param reason The drop reason.
  */
 void
 PhyRxDropTrace(std::string context, Ptr<const Packet> p, WifiPhyRxfailureReason reason)
@@ -2168,8 +2173,8 @@
 /**
  * PHY RX end trace
  *
- * \param context The context.
- * \param p The packet.
+ * @param context The context.
+ * @param p The packet.
  */
 void
 PhyRxDoneTrace(std::string context, Ptr<const Packet> p)
@@ -2181,11 +2186,11 @@
 /**
  * PHY successful RX trace
  *
- * \param context The context.
- * \param p The packet.
- * \param snr The SNR.
- * \param mode The WiFi mode.
- * \param preamble The preamble.
+ * @param context The context.
+ * @param p The packet.
+ * @param snr The SNR.
+ * @param mode The WiFi mode.
+ * @param preamble The preamble.
  */
 void
 PhyRxOkTrace(std::string context,
@@ -2220,9 +2225,9 @@
 /**
  * PHY RX error trace
  *
- * \param context The context.
- * \param p The packet.
- * \param snr The SNR.
+ * @param context The context.
+ * @param p The packet.
+ * @param snr The SNR.
  */
 void
 PhyRxErrorTrace(std::string context, Ptr<const Packet> p, double snr)
@@ -2239,9 +2244,9 @@
 /**
  * PHY TX trace
  *
- * \param context The context.
- * \param p The packet.
- * \param txPowerW The TX power.
+ * @param context The context.
+ * @param p The packet.
+ * @param txPowerW The TX power.
  */
 void
 PhyTxTrace(std::string context, Ptr<const Packet> p, double txPowerW)
@@ -2263,8 +2268,8 @@
 /**
  * PHY TX end trace.
  *
- * \param context The context.
- * \param p The packet.
+ * @param context The context.
+ * @param p The packet.
  */
 void
 PhyTxDoneTrace(std::string context, Ptr<const Packet> p)
@@ -2276,8 +2281,8 @@
 /**
  * MAC TX trace.
  *
- * \param context The context.
- * \param p The packet.
+ * @param context The context.
+ * @param p The packet.
  */
 void
 MacTxTrace(std::string context, Ptr<const Packet> p)
@@ -2292,8 +2297,8 @@
 /**
  * MAC RX trace.
  *
- * \param context The context.
- * \param p The packet.
+ * @param context The context.
+ * @param p The packet.
  */
 void
 MacRxTrace(std::string context, Ptr<const Packet> p)
@@ -2308,9 +2313,9 @@
 /**
  * Socket send trace.
  *
- * \param context The context.
- * \param p The packet.
- * \param addr destination address.
+ * @param context The context.
+ * @param p The packet.
+ * @param addr destination address.
  */
 void
 SocketSendTrace(std::string context, Ptr<const Packet> p, const Address& addr)
@@ -2325,8 +2330,8 @@
 /**
  * Association log trace.
  *
- * \param context The context.
- * \param address The MAC address.
+ * @param context The context.
+ * @param address The MAC address.
  */
 void
 AssociationLog(std::string context, Mac48Address address)
@@ -2347,8 +2352,8 @@
 /**
  * Deassociation log trace.
  *
- * \param context The context.
- * \param address The MAC address.
+ * @param context The context.
+ * @param address The MAC address.
  */
 void
 DisassociationLog(std::string context, Mac48Address address)
@@ -2389,21 +2394,21 @@
     /**
      * Configure and run the experiment.
      *
-     * \param wifi the pre-configured WifiHelper
-     * \param wifiPhy the pre-configured YansWifiPhyHelper
-     * \param wifiMac the pre-configured WifiMacHelper
-     * \param wifiChannel the pre-configured YansWifiChannelHelper
-     * \param trialNumber the trial index
-     * \param networkSize the number of stations
-     * \param duration the duration of each simulation run
-     * \param pcap flag to enable/disable PCAP files generation
-     * \param infra flag to enable infrastructure model, ring adhoc network if not set
-     * \param guardIntervalNs the guard interval in ns
-     * \param distance the distance
-     * \param apTxPower the AP transmit power
-     * \param staTxPower the STA transmit power
-     * \param pktInterval the packet interval
-     * \return 0 if all went well
+     * @param wifi the pre-configured WifiHelper
+     * @param wifiPhy the pre-configured YansWifiPhyHelper
+     * @param wifiMac the pre-configured WifiMacHelper
+     * @param wifiChannel the pre-configured YansWifiChannelHelper
+     * @param trialNumber the trial index
+     * @param networkSize the number of stations
+     * @param duration the duration of each simulation run
+     * @param pcap flag to enable/disable PCAP files generation
+     * @param infra flag to enable infrastructure model, ring adhoc network if not set
+     * @param guardIntervalNs the guard interval in ns
+     * @param distance the distance
+     * @param apTxPower the AP transmit power
+     * @param staTxPower the STA transmit power
+     * @param pktInterval the packet interval
+     * @return 0 if all went well
      */
     int Run(const WifiHelper& wifi,
             const YansWifiPhyHelper& wifiPhy,
@@ -2632,6 +2637,24 @@
     Config::Connect("/NodeList/*/$ns3::Node/ApplicationList/*/$ns3::PacketSocketClient/Tx",
                     MakeCallback(&SocketSendTrace));
 
+    WifiTxStatsHelper wifiTxStats;
+    if (useTxHelper)
+    {
+        // Setup Wi-Fi Transmission Statistics Helper (WifiTxStatsHelper) for all devices
+        wifiTxStats.Enable(devices);
+        wifiTxStats.Start(Seconds(10));
+        wifiTxStats.Stop(Seconds(10) + duration);
+    }
+
+    WifiPhyRxTraceHelper rxTraceHelper;
+    if (useRxHelper)
+    {
+        // Setup Wi-Fi PHY Reception Trace Helper (WifiPhyRxTraceHelper) for all devices
+        rxTraceHelper.Enable(devices);
+        rxTraceHelper.Start(Seconds(10));
+        rxTraceHelper.Stop(Seconds(10) + duration);
+    }
+
     Simulator::Schedule(Seconds(10), &RestartCalc);
     Simulator::Stop(Seconds(10) + duration);
 
@@ -2643,6 +2666,151 @@
     Simulator::Run();
     Simulator::Destroy();
 
+    if (useTxHelper)
+    {
+        // Get results from WifiTxStatsHelper
+        const auto numSuccessPerNodeDevice = wifiTxStats.GetSuccessesByNodeDevice();
+        const auto numFailurePerNodeDevice = wifiTxStats.GetFailuresByNodeDevice();
+        const auto numFailureDueToFailedEnqueuePerNodeDevice =
+            wifiTxStats.GetFailuresByNodeDevice(WIFI_MAC_DROP_FAILED_ENQUEUE);
+        const auto numFailureDueToExpiredLifetimePerNodeDevice =
+            wifiTxStats.GetFailuresByNodeDevice(WIFI_MAC_DROP_EXPIRED_LIFETIME);
+        const auto numFailureDueToRetryLimitReachedPerNodeDevice =
+            wifiTxStats.GetFailuresByNodeDevice(WIFI_MAC_DROP_REACHED_RETRY_LIMIT);
+        const auto numFailureDueToQosOldPacketPerNodeDevice =
+            wifiTxStats.GetFailuresByNodeDevice(WIFI_MAC_DROP_QOS_OLD_PACKET);
+        const auto numRetransPerNodeDevice = wifiTxStats.GetRetransmissionsByNodeDevice();
+        std::cout << "WifiTxStatsHelper: node to number of MPDUs acked during (10, "
+                  << 10 + duration.ToInteger(Time::S) << "] s:" << std::endl;
+        if (numSuccessPerNodeDevice.empty())
+        {
+            std::cout << "none\n";
+        }
+        else
+        {
+            std::cout << std::setw(5) << "node" << std::setw(10) << "nSuccess" << std::endl;
+            for (const auto& [nodeDevTuple, nSuccess] : numSuccessPerNodeDevice)
+            {
+                std::cout << std::setw(5) << std::get<0>(nodeDevTuple) << std::setw(10) << nSuccess
+                          << std::endl;
+            }
+        }
+        std::cout
+            << "WifiTxStatsHelper: node to number of MPDUs failed (due to any reason) during (10, "
+            << 10 + duration.ToInteger(Time::S) << "] s:" << std::endl;
+        if (numFailurePerNodeDevice.empty())
+        {
+            std::cout << "none\n";
+        }
+        else
+        {
+            std::cout << std::setw(5) << "node" << std::setw(10) << "nFailed" << std::endl;
+            for (const auto& [nodeDevTuple, nFailure] : numFailurePerNodeDevice)
+            {
+                std::cout << std::setw(5) << std::get<0>(nodeDevTuple) << std::setw(10) << nFailure
+                          << std::endl;
+            }
+            std::cout << "WifiTxStatsHelper: node to number of MPDUs failed (due to "
+                         "WIFI_MAC_DROP_FAILED_ENQUEUE) during (10, "
+                      << 10 + duration.ToInteger(Time::S) << "] s:" << std::endl;
+            if (numFailureDueToFailedEnqueuePerNodeDevice.empty())
+            {
+                std::cout << "none\n";
+            }
+            else
+            {
+                std::cout << std::setw(5) << "node" << std::setw(10) << "nFailed" << std::endl;
+                for (const auto& [nodeDevTuple, nFailure] :
+                     numFailureDueToFailedEnqueuePerNodeDevice)
+                {
+                    std::cout << std::setw(5) << std::get<0>(nodeDevTuple) << std::setw(10)
+                              << nFailure << std::endl;
+                }
+            }
+            std::cout << "WifiTxStatsHelper: node to number of MPDUs failed (due to "
+                         "WIFI_MAC_DROP_EXPIRED_LIFETIME) during (10, "
+                      << 10 + duration.ToInteger(Time::S) << "] s:" << std::endl;
+            if (numFailureDueToExpiredLifetimePerNodeDevice.empty())
+            {
+                std::cout << "none\n";
+            }
+            else
+            {
+                std::cout << std::setw(5) << "node" << std::setw(10) << "nFailed" << std::endl;
+                for (const auto& [nodeDevTuple, nFailure] :
+                     numFailureDueToExpiredLifetimePerNodeDevice)
+                {
+                    std::cout << std::setw(5) << std::get<0>(nodeDevTuple) << std::setw(10)
+                              << nFailure << std::endl;
+                }
+            }
+            std::cout << "WifiTxStatsHelper: node to number of MPDUs failed (due to "
+                         "WIFI_MAC_DROP_REACHED_RETRY_LIMIT) during (10, "
+                      << 10 + duration.ToInteger(Time::S) << "] s:" << std::endl;
+            if (numFailureDueToRetryLimitReachedPerNodeDevice.empty())
+            {
+                std::cout << "none\n";
+            }
+            else
+            {
+                std::cout << std::setw(5) << "node" << std::setw(10) << "nFailed" << std::endl;
+                for (const auto& [nodeDevTuple, nFailure] :
+                     numFailureDueToRetryLimitReachedPerNodeDevice)
+                {
+                    std::cout << std::setw(5) << std::get<0>(nodeDevTuple) << std::setw(10)
+                              << nFailure << std::endl;
+                }
+            }
+            std::cout << "WifiTxStatsHelper: node to number of MPDUs failed (due to "
+                         "WIFI_MAC_DROP_QOS_OLD_PACKET) during (10, "
+                      << 10 + duration.ToInteger(Time::S) << "] s:" << std::endl;
+            if (numFailureDueToQosOldPacketPerNodeDevice.empty())
+            {
+                std::cout << "none\n";
+            }
+            else
+            {
+                std::cout << std::setw(5) << "node" << std::setw(10) << "nFailed" << std::endl;
+                for (const auto& [nodeDevTuple, nFailure] :
+                     numFailureDueToQosOldPacketPerNodeDevice)
+                {
+                    std::cout << std::setw(5) << std::get<0>(nodeDevTuple) << std::setw(10)
+                              << nFailure << std::endl;
+                }
+            }
+        }
+        std::cout << "WifiTxStatsHelper: node to number of retransmissions of MPDUs "
+                     "Acked during (10, "
+                  << 10 + duration.ToInteger(Time::S) << "] s:" << std::endl;
+        if (numRetransPerNodeDevice.empty())
+        {
+            std::cout << "none\n";
+        }
+        else
+        {
+            std::cout << std::setw(5) << "node" << std::setw(10) << "nRetrans" << std::endl;
+            for (const auto& [nodeDevTuple, nRetrans] : numRetransPerNodeDevice)
+            {
+                std::cout << std::setw(5) << std::get<0>(nodeDevTuple) << std::setw(10) << nRetrans
+                          << std::endl;
+            }
+        }
+    }
+
+    if (useRxHelper)
+    {
+        // Get results from WifiPhyRxTraceHelper
+        std::cout << "\nWifiPhyRxTraceHelper: overall statistics" << std::endl;
+        rxTraceHelper.PrintStatistics();
+        for (uint32_t nodeIndex = 0; nodeIndex < nNodes; ++nodeIndex)
+        {
+            std::cout << "\nWifiPhyRxTraceHelper: per-node statistics for node " << nodeIndex
+                      << std::endl;
+            rxTraceHelper.PrintStatistics(nodeIndex);
+        }
+        std::cout << std::endl;
+    }
+
     if (tracing)
     {
         cwTraceFile.flush();
@@ -2659,9 +2827,9 @@
 /**
  * Get the Counter associated with a MAC address.
  *
- * \param counter The map of counters to inspect.
- * \param addr The MAC address.
- * \return the value of the counter,
+ * @param counter The map of counters to inspect.
+ * @param addr The MAC address.
+ * @return the value of the counter,
  */
 uint64_t
 GetCount(const std::map<Mac48Address, uint64_t>& counter, Mac48Address addr)
@@ -2706,18 +2874,15 @@
         1000; ///< The socket packet interval in microseconds (a higher value is needed to reach
               ///< saturation conditions as the channel bandwidth or the MCS increases)
     meter_u distance = 0.001; ///< The distance in meters between the AP and the STAs
-    dBm_u apTxPower = 16;     ///< The transmit power of the AP (if infrastructure only)
-    dBm_u staTxPower = 16;    ///< The transmit power of each STA (or all STAs if adhoc)
+    dBm_u apTxPower{16};      ///< The transmit power of the AP (if infrastructure only)
+    dBm_u staTxPower{16};     ///< The transmit power of each STA (or all STAs if adhoc)
 
     // Disable fragmentation and RTS/CTS
     Config::SetDefault("ns3::WifiRemoteStationManager::FragmentationThreshold",
                        StringValue("22000"));
     Config::SetDefault("ns3::WifiRemoteStationManager::RtsCtsThreshold", StringValue("22000"));
-    // Disable short retransmission failure (make retransmissions persistent)
-    Config::SetDefault("ns3::WifiRemoteStationManager::MaxSlrc",
-                       UintegerValue(std::numeric_limits<uint32_t>::max()));
-    Config::SetDefault("ns3::WifiRemoteStationManager::MaxSsrc",
-                       UintegerValue(std::numeric_limits<uint32_t>::max()));
+    // Make CW stay equal to CWmax until a packet is acknowledged
+    Config::SetDefault("ns3::WifiMac::FrameRetryLimit", UintegerValue(65535));
     // Set maximum queue size to the largest value and set maximum queue delay to be larger than the
     // simulation time
     Config::SetDefault(
@@ -2730,6 +2895,8 @@
                  "Logging level (0: no log - 1: simulation script logs - 2: all logs)",
                  verbose);
     cmd.AddValue("tracing", "Generate trace files", tracing);
+    cmd.AddValue("useTxHelper", "Enable WifiTxStatsHelper on all devices", useTxHelper);
+    cmd.AddValue("useRxHelper", "Enable WifiPhyRxTraceHelper on all devices", useRxHelper);
     cmd.AddValue("pktSize", "The packet size in bytes", pktSize);
     cmd.AddValue("trials", "The maximal number of runs per network size", trials);
     cmd.AddValue("duration", "Time duration for each trial in seconds", duration);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/examples/wifi-co-trace-example.cc ns-3.44/src/wifi/examples/wifi-co-trace-example.cc
--- ns-3.43/src/wifi/examples/wifi-co-trace-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/wifi/examples/wifi-co-trace-example.cc	2025-03-09 16:55:49.775372500 -0700
@@ -0,0 +1,221 @@
+/*
+ * Copyright (c) 2024 University of Washington (updated to 802.11ax standard)
+ * Copyright (c) 2009 The Boeing Company
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ */
+
+// The purpose of this example is to illustrate basic use of the
+// WifiCoTraceHelper on a simple example program.
+//
+// This script configures four 802.11ax Wi-Fi STAs on a YansWifiChannel,
+// with devices in infrastructure mode, and each STA sends a saturating load
+// of UDP datagrams to the AP for a specified simulation duration. A simple
+// free-space path loss (Friis) propagation loss model is configured.
+// The lowest MCS ("HeMcs0") value is configured.
+//
+// At the end of the simulation, a channel occupancy report is printed for
+// each STA and for the AP.  There are two program options:
+// -- duration:
+// -- useDifferentAc:  (true or false)
+//
+// If 'useDifferentAc' has the value false, all STAs will have the same EDCA parameters
+// for best effort) and their channel utilization (the TX time output of the
+// channel access helper) will be close to equal.  If 'useDifferentAc' is true,
+// then two of the four STAs will instead be configured to use the voice
+// access category, and channel utilization will be different due to the
+// different EDCA parameters.
+
+#include "ns3/boolean.h"
+#include "ns3/command-line.h"
+#include "ns3/config.h"
+#include "ns3/double.h"
+#include "ns3/internet-stack-helper.h"
+#include "ns3/ipv4-address-helper.h"
+#include "ns3/log.h"
+#include "ns3/mobility-helper.h"
+#include "ns3/mobility-model.h"
+#include "ns3/names.h"
+#include "ns3/neighbor-cache-helper.h"
+#include "ns3/on-off-helper.h"
+#include "ns3/packet-sink-helper.h"
+#include "ns3/ssid.h"
+#include "ns3/string.h"
+#include "ns3/uinteger.h"
+#include "ns3/wifi-co-trace-helper.h"
+#include "ns3/wifi-phy-rx-trace-helper.h"
+#include "ns3/yans-wifi-channel.h"
+#include "ns3/yans-wifi-helper.h"
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("WifiCoTraceExample");
+
+// Function for runtime manual ARP configuration
+void
+PopulateNeighborCache()
+{
+    NeighborCacheHelper neighborCache;
+    neighborCache.PopulateNeighborCache();
+}
+
+int
+main(int argc, char* argv[])
+{
+    bool useDifferentAc = false;
+    Time duration{Seconds(10)};
+    double distance = 1; // meters
+
+    CommandLine cmd(__FILE__);
+    cmd.AddValue("useDifferentAc",
+                 "Uses VO AC on 2 STAs and BE on rest if true. Uses BE AC on all 4 STAs if false.",
+                 useDifferentAc);
+    cmd.AddValue("duration", "Duration of data transfer", duration);
+    cmd.Parse(argc, argv);
+
+    NodeContainer apNode(1);
+    Names::Add("AP", apNode.Get(0));
+    NodeContainer staNodes(4);
+    Names::Add("STA0", staNodes.Get(0));
+    Names::Add("STA1", staNodes.Get(1));
+    Names::Add("STA2", staNodes.Get(2));
+    Names::Add("STA3", staNodes.Get(3));
+
+    MobilityHelper mobility;
+    Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
+    positionAlloc->Add(Vector(0.0, 0.0, 0.0));
+    mobility.SetPositionAllocator(positionAlloc);
+    mobility.SetMobilityModel("ns3::ConstantPositionMobilityModel");
+    mobility.Install(apNode);
+    positionAlloc = CreateObject<ListPositionAllocator>();
+    positionAlloc->Add(Vector(distance, 0.0, 0.0));
+    positionAlloc->Add(Vector(0.0, distance, 0.0));
+    positionAlloc->Add(Vector(0.0, -distance, 0.0));
+    positionAlloc->Add(Vector(-distance, 0.0, 0.0));
+    mobility.Install(staNodes);
+
+    WifiHelper wifi;
+    wifi.SetStandard(WIFI_STANDARD_80211ax);
+
+    YansWifiPhyHelper wifiPhy;
+    YansWifiChannelHelper wifiChannel;
+    wifiChannel.SetPropagationDelay("ns3::ConstantSpeedPropagationDelayModel");
+    wifiChannel.AddPropagationLoss("ns3::FriisPropagationLossModel");
+    wifiPhy.SetChannel(wifiChannel.Create());
+
+    // Add a mac and disable rate control
+    WifiMacHelper wifiMac;
+    wifi.SetRemoteStationManager("ns3::ConstantRateWifiManager",
+                                 "DataMode",
+                                 StringValue("HeMcs0"),
+                                 "ControlMode",
+                                 StringValue("HeMcs0"));
+
+    // Setup the rest of the MAC
+    Ssid ssid = Ssid("wifi-default");
+    // setup AP to beacon roughly once per second (must be a multiple of 1024 us)
+    wifiMac.SetType("ns3::ApWifiMac",
+                    "Ssid",
+                    SsidValue(ssid),
+                    "QosSupported",
+                    BooleanValue(true),
+                    "BeaconInterval",
+                    TimeValue(MilliSeconds(1024)));
+    NetDeviceContainer apDevice = wifi.Install(wifiPhy, wifiMac, apNode);
+
+    // setup STA and disable the possible loss of association due to missed beacons
+    wifiMac.SetType("ns3::StaWifiMac",
+                    "Ssid",
+                    SsidValue(ssid),
+                    "QosSupported",
+                    BooleanValue(true),
+                    "MaxMissedBeacons",
+                    UintegerValue(std::numeric_limits<uint32_t>::max()));
+    NetDeviceContainer staDevices = wifi.Install(wifiPhy, wifiMac, staNodes);
+
+    NetDeviceContainer allDevices;
+    allDevices.Add(apDevice);
+    allDevices.Add(staDevices);
+
+    InternetStackHelper internet;
+    internet.Install(apNode);
+    internet.Install(staNodes);
+
+    Ipv4AddressHelper ipv4;
+    ipv4.SetBase("10.1.1.0", "255.255.255.0");
+    Ipv4InterfaceContainer i = ipv4.Assign(allDevices);
+
+    uint16_t portNumber = 9;
+    std::vector<uint8_t> tosValues = {0x70, 0x28, 0xb8, 0xc0}; // AC_BE, AC_BK, AC_VI, AC_VO
+    auto ipv4ap = apNode.Get(0)->GetObject<Ipv4>();
+    const auto address = ipv4ap->GetAddress(1, 0).GetLocal();
+
+    ApplicationContainer sourceApplications;
+    ApplicationContainer sinkApplications;
+    for (uint32_t i = 0; i < 4; i++)
+    {
+        InetSocketAddress sinkAddress(address, portNumber + i);
+        PacketSinkHelper packetSinkHelper("ns3::UdpSocketFactory", sinkAddress);
+        sinkApplications.Add(packetSinkHelper.Install(apNode.Get(0)));
+        OnOffHelper onOffHelper("ns3::UdpSocketFactory", sinkAddress);
+        onOffHelper.SetAttribute("OnTime", StringValue("ns3::ConstantRandomVariable[Constant=1]"));
+        onOffHelper.SetAttribute("OffTime", StringValue("ns3::ConstantRandomVariable[Constant=0]"));
+        onOffHelper.SetAttribute("DataRate", DataRateValue(2000000)); // bits/sec
+        onOffHelper.SetAttribute("PacketSize", UintegerValue(1472));  // bytes
+        if (!useDifferentAc)
+        {
+            onOffHelper.SetAttribute("Tos", UintegerValue(tosValues[0])); // AC_BE
+        }
+        else
+        {
+            onOffHelper.SetAttribute("Tos",
+                                     UintegerValue(tosValues[3 * (i % 2)])); // AC_BE and AC_VO
+        }
+        sourceApplications.Add(onOffHelper.Install(staNodes.Get(i)));
+    }
+
+    sinkApplications.Start(Seconds(0.0));
+    sinkApplications.Stop(Seconds(1.0) + duration + MilliSeconds(20));
+    sourceApplications.Start(Seconds(1.0));
+    sourceApplications.Stop(Seconds(1.0) + duration);
+
+    // Use the NeighborCacheHelper to avoid ARP messages (ARP replies, since they are unicast,
+    // count in the statistics.  The cache operation must be scheduled after WifiNetDevices are
+    // started, until issue #851 is fixed.  The indirection through a normal function is
+    // necessary because NeighborCacheHelper::PopulateNeighborCache() is overloaded
+    Simulator::Schedule(Seconds(0.99), &PopulateNeighborCache);
+
+    WifiCoTraceHelper wifiCoTraceHelper(Seconds(1), Seconds(1) + duration);
+    wifiCoTraceHelper.Enable(allDevices);
+
+    Simulator::Stop(duration + Seconds(2));
+    Simulator::Run();
+
+    // The following provide some examples of how to access and print the trace helper contents.
+    std::cout << "*** Print statistics for all nodes using built-in print method:" << std::endl;
+    wifiCoTraceHelper.PrintStatistics(std::cout);
+
+    std::cout << "*** Print the statistics in your own way.  Here, just sum the STAs total TX time:"
+              << std::endl
+              << std::endl;
+
+    auto records = wifiCoTraceHelper.GetDeviceRecords();
+    Time sumStaTxTime;
+    for (const auto& it : records)
+    {
+        if (it.m_nodeId > 0)
+        {
+            const auto it2 = it.m_linkStateDurations.at(0).find(WifiPhyState::TX);
+            if (it2 != it.m_linkStateDurations.at(0).end())
+            {
+                sumStaTxTime += it2->second;
+            }
+        }
+    }
+
+    std::cout << "Sum of STA time in TX state is " << sumStaTxTime.As(Time::S) << std::endl;
+
+    Simulator::Destroy();
+
+    return 0;
+}
